# CSK 008: Metadata, Minting, and Messing with Unsigs
## An exploration of Python and Cardano

![914017](/python/914017.png)

### YouTube Video Links:
- [Parts 1 and 2: Metadata, Minting, and Messing with Unsigs](https://youtu.be/GQ6VejWM36U)
- [Part 3: Minting NFTs "The Hard Way" & Notes on Ingenuity](https://youtu.be/eWoDnLUrxUw)
- [Bonus: Let's use Python to Generate Some Unsigs](https://youtu.be/51a1X6iUODg)



### This CSK is for you if:
1. You're new to development and want to play with Python, which might just be the best language for beginners!
2. You're a developer who wants to understand more about how Cardano works.
3. You're not a developer, but you'd like to understand a little more about what's happening when an NFT is minted.
4. Unsigs captured your attention and you'd like to tinker a bit.

Note: if you're looking for a comprehensive explainer on how to mint NFTs, this is *not quite* it. I'm not going to go very deep into NFT storage, because it's a big, messy problem that hasn't really been solved yet. If you'd like to learn more about that, [join us at Gimbalabs](https://discord.gg/XTvJBj7kzq): we're working on it!

### Part 1: What is an Unsig and where can I find it?
This Cardano Starter Kit (CSK) picks up from where the previous one left off. In [CSK #007](https://youtu.be/XVHwWEbExOo), we looked at how to build transactions "the hard way," by going step-by-step in `cardano-cli`. We're not going to do all of that again, but we are going to revisit most of those topics again, so familiarity is recommended.

First, we'll look at how you can navigate transactions in a blockchain explorer to see information about NFTs. As we search Cardano for the Unsig "source code," we'll make the distinctions between:

- Sending assets vs. Minting assets
- Minting policies vs. metadata

#### Helpful Links
- [Unsig #00000 on Cardanoscan.io](https://cardanoscan.io/transaction/e4a90da18935e73f7fd6ffaa688b35b011a1a8a710b47bdb5d7103a05afc0197)
- [Unsig #00000 on Cardano Explorer](https://explorer.cardano.org/en/transaction?id=e4a90da18935e73f7fd6ffaa688b35b011a1a8a710b47bdb5d7103a05afc0197)
- [Cardano Improvement Proposal about CNFT Standards](https://cips.cardano.org/cips/cip25/)
- [OG Discussion about CNFT Standards](https://forum.cardano.org/t/cip-nft-metadata-standard/45687/)
- [CSK #004 - Introductory exploration of metadata](https://github.com/GimbaLabs/csk-004)
- [CSK #006 - A deeper dive into metadata](https://gimbalabs.com/cardanostarterkits/csk006)

### Part 2: Python - How can I generate my own Unsigs?
Let's take a look at the code. Is there really enough information on chain to make my own Unsigs?

Absolutely! This Starter Kit will show you how!

Good developers don't repeat themselves. In fact, as often as possible, developers try not to re-invent anything unless it's really necessary. This is why packages and package manangers exist.

#### Design Patterns and Package Managers
- In a well established software ecosystem, there are well-established "design patterns" that represent tried and true ways of doing things.
- Software "packages" allow developers to build without starting from scratch
- The best developers work efficiently by ensuring that they never have to re-invent anything - unless, of course, they want to learn more about how something works!

####

#### Helpful Links:
- [NumPy](https://numpy.org/)
- [Pillow `Image` module](https://pillow.readthedocs.io/en/stable/reference/Image.html)
- [Python books from No Starch Press](https://nostarch.com/catalog/python)

### Part 3: How can I make my own NFTs?

Well, it depends on what you mean by making NFTs! The best way to quickly mint an NFT is by using a third-party tool like [nft-maker.io](https://www.nft-maker.io/) or [GameChanger Wallet](https://gamechanger.finance). I am a huge fan of GameChanger's interface and Gimbalabs is supporting its development.

But for now, I'd like to shift our focus a bit.

If you want to go deeper in to Python, you'll do that.
If you want an NFT, you can go get one.

I'd like to launch you into some problem solving

1. Emerging design patterns and innovative use of Cardano's tools: [look at how much money Alex saved](https://youtu.be/eWoDnLUrxUw?t=860) by working smart!
2. Where are the images anyway? Who are we relying upon?

### Final Results:
[Check out these CSK008 Unsigs on Pool.pm](https://pool.pm/addr1qygsn6p33aq936phlrx6usd7mguqnnfea9s9ruwuhqcvlhsdu706suvddaa3zf095hfjgnxfex3xuwut8m4nshyjmxfsjcfewq/dabed97d) - it's a super-limited edition of 17. Want one + want to support builders at Gimbalabs? Hit me up.







#### Raw Images: IPFS
- 914001: ipfs://bafybeihs73xt736beukwpasbrepaubnzuawj7airqt7pxfwn5ufyrbogei
- 914002: ipfs://bafybeihuptr6gjxt2sm43bbwkmy3dz7ktlcd52xygtvrosoodeo7pc7vjq
- 914003: ipfs://bafybeifzxktesnbtgjtr6lhfskfohi4en6jl2cijyaz5e7mruvt372ssiy
- 914004: ipfs://bafkreifblhmuoxzehida5ri67lun5pblcaewb255mlkfvkdkye5usbrqca
- 914005: ipfs://bafkreifpixinwtq2zkkzskfoxbx7ivsn2dmbptan66gkuosumzjvb3zk24
- 914006: ipfs://bafkreiamlp5txwbjvtoazr2zum3miysi5tgzlxfgq6hrtlocilwcmjqkm4
- 914007: ipfs://bafkreianq7kmj6emy2boqwlvjexnkghw25tif7llwgqqtin4gyciqvtzem
- 914008: ipfs://bafkreiddcki5z2v7llaautmcf4asdsh7dst5hx6qk7r2xu5f3vpzpxk2qa
- 914009: ipfs://bafkreidd22kfhu5xtgfz6ocrs4nankizpteyol6nfkflhpaf7go7ed66oq
- 914010: ipfs://bafkreienjbpe3h4cv7kk7ew37lpgbaohr3eoa3adjytai56f2v64keouvi
- 914011: ipfs://bafybeiclmuqquf2vegcfwprgsfb2u7gzkwl42lffau7ookqajefowwyvwu
- 914012: ipfs://bafybeihzm2aijtwnw2buwnzntkxilcbdbz2r3btv5pvucqwo6h72xxqw7y
- 914013: ipfs://bafybeibf6hstqiazfop4zmbrhpuadinvtazafxru5l5mu5pvsqdqbyrgum
- 914014: ipfs://bafybeih2lz4ks4krxrku7lwqmg6imjwgwwy7vhtumxxc3ogmug7tof7ula
- 914015: ipfs://bafybeiea7v25wcpfqlga6mrwom2codo3dsnwyxc6jrqn2hbfx4ve6bp6v4
- 914016: ipfs://bafybeie3uphqiwwoftltmqy6o4pifzrakj6muli23iqksk5d4wsgdc3dr4
- 914017: ipfs://bafybeidbxkevo6hkba5ep2fbyofv67rareqndjvcwechoyh5qjpqnnpeza

#### Friendlier Links (If you don't run an IPFS node)
- 914001: https://bafybeihs73xt736beukwpasbrepaubnzuawj7airqt7pxfwn5ufyrbogei.ipfs.dweb.link/
- 914002: https://bafybeihuptr6gjxt2sm43bbwkmy3dz7ktlcd52xygtvrosoodeo7pc7vjq.ipfs.dweb.link/
- 914003: https://bafybeifzxktesnbtgjtr6lhfskfohi4en6jl2cijyaz5e7mruvt372ssiy.ipfs.dweb.link/
- 914004: https://bafkreifblhmuoxzehida5ri67lun5pblcaewb255mlkfvkdkye5usbrqca.ipfs.dweb.link/
- 914005: https://bafkreifpixinwtq2zkkzskfoxbx7ivsn2dmbptan66gkuosumzjvb3zk24.ipfs.dweb.link/
- 914006: https://bafkreiamlp5txwbjvtoazr2zum3miysi5tgzlxfgq6hrtlocilwcmjqkm4.ipfs.dweb.link/
- 914007: https://bafkreianq7kmj6emy2boqwlvjexnkghw25tif7llwgqqtin4gyciqvtzem.ipfs.dweb.link/
- 914008: https://bafkreiddcki5z2v7llaautmcf4asdsh7dst5hx6qk7r2xu5f3vpzpxk2qa.ipfs.dweb.link/
- 914009: https://bafkreidd22kfhu5xtgfz6ocrs4nankizpteyol6nfkflhpaf7go7ed66oq.ipfs.dweb.link/
- 914010: https://bafkreienjbpe3h4cv7kk7ew37lpgbaohr3eoa3adjytai56f2v64keouvi.ipfs.dweb.link/
- 914011: https://bafybeiclmuqquf2vegcfwprgsfb2u7gzkwl42lffau7ookqajefowwyvwu.ipfs.dweb.link/
- 914012: https://bafybeihzm2aijtwnw2buwnzntkxilcbdbz2r3btv5pvucqwo6h72xxqw7y.ipfs.dweb.link/
- 914013: https://bafybeibf6hstqiazfop4zmbrhpuadinvtazafxru5l5mu5pvsqdqbyrgum.ipfs.dweb.link/
- 914014: https://bafybeih2lz4ks4krxrku7lwqmg6imjwgwwy7vhtumxxc3ogmug7tof7ula.ipfs.dweb.link/
- 914015: https://bafybeiea7v25wcpfqlga6mrwom2codo3dsnwyxc6jrqn2hbfx4ve6bp6v4.ipfs.dweb.link/
- 914016: https://bafybeie3uphqiwwoftltmqy6o4pifzrakj6muli23iqksk5d4wsgdc3dr4.ipfs.dweb.link/
- 914017: https://bafybeidbxkevo6hkba5ep2fbyofv67rareqndjvcwechoyh5qjpqnnpeza.ipfs.dweb.link/